function val = associated_legendre(n,m,x)
if ~isscalar(n) || n < 0 || n ~= round(n)
    error('invalid n');
end

if ~isreal(x) || max(abs(x(:))) > 1
    error('x should be between -1 and 1')
end
if ~isscalar(m) || abs(m) >n || m ~= round(m)
    error('invalid m');
end

% recursively calculate the terms
if m>= 0
if n == m
val =  (-1).^m*factorial(2.*m)./factorial(m)./2.^m.*(1-x.^2).^(m./2); % P_m^m
return
end
if n == m+1
term1 = (-1).^m*factorial(2.*m)./factorial(m)./2.^m.*(1-x.^2).^(m./2); % P_m^m
val = x.*(2.*m+1).*term1; % P_m+1^m
return
end

val = 1./(n-m).*(associated_legendre(n-1,m,x).*(2.*n-1).*x - associated_legendre(n-2,m,x).*(n-1+m));
else
val = (-1).^abs(m).*factorial(n-abs(m))./factorial(n+abs(m))*associated_legendre(n,abs(m),x);

end